#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#define nl endl
#else
#define nl '\n'
#pragma GCC optimize("Ofast")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define _ <<" "<<
#define pb push_back
#define eb emplace_back
#define ll long long
#define ld long double
#define ull unsigned long long

struct segtree {
    struct node {
        int mx = 0, ind = -1;

        node() = default;

        node(int mx, int ind) : mx(mx), ind(ind) {}
    };

    node merge(node a, node b) {
        return a.mx > b.mx ? a : b;
    }

    int n, N;
    vector<node> t;

    void build(int v, int l, int r, vector<int> &a) {
        if (r - l == 1) {
            if (l < n) t[v] = {a[l], l};
            return;
        }
        int m = (r + l) / 2;
        build(v * 2 + 1, l, m, a);
        build(v * 2 + 2, m, r, a);
        t[v] = merge(t[v * 2 + 1], t[v * 2 + 2]);
    }

    segtree(vector<int> &a) {
        n = a.size();
        N = 1 << (__lg(n - 1) + 1);
        t.resize(4 * n);
        build(0, 0, N, a);
    }

    node get(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr) return t[v];
        if (r <= ql || qr <= l) return {};
        int m = (r + l) / 2;
        return merge(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
    }

    node get(int l, int r) {
        return get(0, 0, N, l, r);
    }
};

void solve() {
    int n;
    cin >> n;

    vector<int> h(n), c(n);
    forn(i, n) cin >> h[i];
    forn(i, n) cin >> c[i];

    segtree st(h);

    function<ll(int, int)> f = [&](int l, int r) -> ll {
        if (r <= l) return 0;
        auto [mx, ind] = st.get(l, r);
        return c[ind] + min(f(l, ind), f(ind + 1, r));
    };

    cout << f(0, n) << nl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);

    int t = 1;
//    cin >> t;
    while (t--) solve();
}