#include <iostream>
#include <algorithm>
#include <vector>

typedef long long ll;

const int inf = (int)1e9 + 1;
const ll big = (ll)1e18 + 1;
const int N = 200000;
int h[N], c[N];

ll dp[N];

struct pillar {
    int h_;
    ll dp_left, dp_right;
};

int main() {
    int n;
    std::cin >> n;
    for (int i = 0; i < n; ++i) {
        std::cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> c[i];
    }

    std::fill(dp, dp + n, big);
    std::vector<pillar> st;
    st.push_back(pillar{inf, 0, big});
    for (int i = 0; i < n; i++) {
        while (st.back().h_ < h[i]) {
            st.pop_back();
        }
        dp[i] = std::min(dp[i], c[i] + st.back().dp_left);
        dp[i] = std::min(dp[i], st.back().dp_right);
        st.push_back(pillar{h[i], dp[i], std::min(st.back().dp_right, c[i] + (i == 0 ? 0 : dp[i - 1]))});
    }
    std::cout << dp[n - 1] << "\n";
}